// *** ================================================================ ***
// ***	MAIL SCAN for QMAIL
// ***	--------------------------------------------------------------
// ***	Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***	Author Contact Address:   
// ***		STARS System Inc. Technical Division.
// ***		2-3-11 Mahikizawa APT #2B
// ***	    Tama-Shi, Tokyo, Japan 206-0023
// ***	    TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***	--------------------------------------------------------------
// ***	Product Functionality 
// ***  
// *** ================================================================ ***

#include "qmail-checker.h"


int main( int nargc, char *pargv[] )
{
	MAIN_INFO_T		gmf ;

	//***
	//***	Initialize 
	//***

	fprintf( stderr, "QMCK: QMAIL-CHECKER START\n" ) ;

	if ( sub_initial_proc( &gmf, nargc, pargv ) != 0 )
	{
		fprintf( stderr, "QMCK: Initial Proc Failed\n" ) ;
		exit(0) ;
	}

	//***
	//***	Copy incomming mail message to working directory
	//***

	if ( sub_copy_mail( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Copy Mail Message Failed\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	//***
	//***	Get Envelope Data
	//***

	if ( sub_get_envelope( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Get Envelope Failed\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	//***
	//***	Dis-Assemble Mail Message
	//***

	if ( sub_disasm_mail( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Copy Mail Message Failed\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	//***
	//***	Check for viruses and spams 
	//***

	if ( sub_check_mail( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Check Mail Message Failed\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	//***
	//***	Trim Mail Message
	//***

	if ( sub_process_mail( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Process Mail Message bounced\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	//***
	//***	Transfer Mail message to original qmail-queue
	//***

	if ( sub_send_qmailque( &gmf ) != 0 )
	{
		fprintf( stderr, "QMCK: Send Mail Message To qmail-que\n" ) ;
		sub_clean_up( &gmf ) ;
		exit(0) ;
	}

	sub_clean_up( &gmf ) ;

	exit(0) ;
}
