// *** ================================================================ ***
// ***  MAIL SCAN for QMAIL
// ***  --------------------------------------------------------------
// ***  Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***  Author Contact Address:
// ***      STARS System Inc. Technical Division.
// ***      2-3-11 Mahikizawa APT #2B
// ***      Tama-Shi, Tokyo, Japan 206-0023
// ***      TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***  --------------------------------------------------------------
// ***  Product Functionality
// ***	Decode Mail Message using ripmime
// *** ================================================================ ***

#include "qmail-checker.h"

int sub_disasm_mail(MAIN_INFO_T *pmf)
{
	int		npid ;
	int		nsts ;
	int		wstat ;
	int		nexit ;
	int		ncras ;
	char	wrkbuf[1024] ;
	char   *exec_args[8] ;

	// ***
	// ***	Make ripmime command line
	// ***

	sprintf( wrkbuf, "%s/mail_message", pmf->path_wrkdir ) ;

	memset ( exec_args, 0, sizeof(exec_args) ) ;

	exec_args[0] = pmf->path_ripmim ; 
	exec_args[1] = "-i" ;
	exec_args[2] = wrkbuf ;
	exec_args[3] = "-d" ;
	exec_args[4] = pmf->path_wrkdir ;

	fprintf( stderr, "QMCK: sub_disasm_mail working on (%s)\n", pmf->path_wrkdir ) ;

	// ***
	// ***	Fork and start ripmime
	// ***

  	switch( npid = vfork() ) 
	{
    case -1:	//	vfork error

		fprintf( stderr, "QMCK: sub_disasm_mail vfork failed\n" ) ;
      	return -1;

    case 0:		//	Child Process

		fprintf(stderr, "QMCK: sub_disasm_mail execute child\n" ) ;
      	execv(exec_args[0],exec_args);
		fprintf(stderr, "QMCK: sub_disasm_mail child ended\n" ) ;
      	_exit(120);
  	}

	// ***
	// ***	wait until ripmime ends
	// ***

  	do
    	nsts = waitpid( npid, &wstat, 0 ) ;
  	while ( (nsts == -1) && (errno == EINTR) ) ;

	nexit = child_status ( wstat ) ;
	ncras = child_crashed( wstat ) ;

	fprintf(stderr, "QMCK: sub_disasm_mail sts=(%d), crashed=(%d)\n", nexit, ncras ) ;

	return 0 ;
}

