// *** ================================================================ ***
// ***  MAIL SCAN for QMAIL
// ***  --------------------------------------------------------------
// ***  Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***  Author Contact Address:
// ***      STARS System Inc. Technical Division.
// ***      2-3-11 Mahikizawa APT #2B
// ***      Tama-Shi, Tokyo, Japan 206-0023
// ***      TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***  --------------------------------------------------------------
// ***  Product Functionality
// ***
// *** ================================================================ ***

#include "qmail-checker.h"

int sub_get_envelope(MAIN_INFO_T *pmf)
{
    char    filbuf[1024] ;
    char    wrkbuf[1024] ;
    int     ndat ;
    int     ncnt ;
	int		nphs ;
    FILE   *fp ;
    FILE   *fs ;

	// ***
	// ***	Get Envelope
	// ***

    if ( (fp = fopen( pmf->path_envelp, "wb" )) == NULL )
    {
        fprintf( stderr, "QMCK: file open error\n" ) ;
        return -1 ;
    }

    ncnt = 0 ;

    while( read( 1, filbuf, 1 ) == 1 )
    {
        ncnt++ ;
        fputc( filbuf[0], fp ) ;
    }

    fclose( fp ) ;

    fprintf( stderr, "QMCK: sub_get_envelope %d bytes loaded\n", ncnt ) ;

	// ***
	// ***	Disassemble envelope
	// ***

	if ( (fp = fopen( pmf->path_envelp, "rb" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_get_envelope failed to open envelope\n" ) ;
		return -1 ;
	}

	sprintf( wrkbuf, "%s/env_data", pmf->path_wrkdir ) ;

	if ( (fs = fopen( wrkbuf, "w" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_get_envelope failed to open (%s)\n", wrkbuf ) ;
		fclose( fp ) ;
		return -1 ;
	}

	memset( filbuf, 0, sizeof(filbuf) ) ;
	nphs = 0 ;

	while( fread( filbuf, 1, 1, fp ) == 1 )
	{
		if ( nphs == 0 )
		{
			switch( filbuf[0] )
			{
			case 'T':
				memset( wrkbuf, 0, sizeof(wrkbuf) ) ;
				nphs = 1 ;
				ncnt = 0 ;
				break ;
			case 'F':
				memset( wrkbuf, 0, sizeof(wrkbuf) ) ;
				nphs = 2 ;
				ncnt = 0 ;
				break ;
				break ;
			case 0:
				break ;
			default:
				fprintf( stderr, "QMCK: sub_get_envelope error (%c:%X)\n", filbuf[0],filbuf[0] ) ;
				fclose ( fp ) ;
				return -1 ;
			}
			
		} else {

			if ( filbuf[0] == 0 )
			{
				switch( nphs )
				{
				case 1:
					fprintf( stderr, "QMCK: sub_get_envelope recipient=(%s)\n", wrkbuf ) ;
					fprintf( fs, "%s\n", wrkbuf ) ;
					break ;
				case 2:
					fprintf( stderr, "QMCK: sub_get_envelope sender=(%s)\n", wrkbuf ) ;
					strcpy ( pmf->mail_from, wrkbuf ) ;
					break ;
				}
				nphs = 0 ;
			} else {
				wrkbuf[ncnt++] = filbuf[0] ;
			}
		}
	}

	fclose( fp ) ;
	fclose( fs ) ;

    return 0 ;
}

