// *** ================================================================ ***
// ***  MAIL SCAN for QMAIL
// ***  --------------------------------------------------------------
// ***  Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***  Author Contact Address:
// ***      STARS System Inc. Technical Division.
// ***      2-3-11 Mahikizawa APT #2B
// ***      Tama-Shi, Tokyo, Japan 206-0023
// ***      TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***  --------------------------------------------------------------
// ***  Product Functionality
// ***
// *** ================================================================ ***

#include "qmail-checker.h"

int sub_initial_proc(MAIN_INFO_T *pmf, int nargc, char *pargv[])
{
	int			nmask ;
	int			npnum ;
	char		wrkbuf[1024] ;
	char		tmpbuf[1024] ;
	char       *pt ;
	struct stat stt ;

	// ***
	// ***	Set Default Information
	// ***

	memset( pmf, 0, sizeof( MAIN_INFO_T ) ) ;
	
	strcpy( pmf->path_qmailq, QMAIL_QUEUE ) ;
	strcpy( pmf->path_ripmim, PATH_RIPMIME ) ;
	strcpy( pmf->path_clamav, PATH_CLAMSCAN ) ;
	strcpy( pmf->path_virusd, DIRC_CLAMDATA ) ;
	strcpy( pmf->mail_addres, MAIL_ADMIN ) ;

	// ***
	// ***	Dynamic Parameter 
	// ***

	if ( (pt = getenv( "QMAIL_QUEUE" )) != NULL )
	{
		strcpy( pmf->path_qmailq, pt ) ;
	}
	if ( (pt = getenv( "PATH_RIPMIME" )) != NULL )
	{
		strcpy( pmf->path_ripmim, pt ) ;
	}
	if ( (pt = getenv( "PATH_CLAMSCAN" )) != NULL )
	{
		strcpy( pmf->path_clamav, pt ) ;
	}
	if ( (pt = getenv( "MAIL_ADMIN" )) != NULL )
	{
		strcpy( pmf->mail_addres, pt ) ;
	}

	// ***
	// ***	Check Temporary Dir
	// ***

	if ( stat( PATH_TEMP_DIR, &stt ) < 0 )
	{
		nmask  = S_ISUID|S_ISGID|S_ISVTX|S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IWGRP|S_IXGRP ;
		nmask |= S_IROTH|S_IWOTH|S_IXOTH ;
		mkdir( PATH_TEMP_DIR, 777 ) ;
		chmod( PATH_TEMP_DIR, nmask ) ;

		if ( stat( PATH_TEMP_DIR, &stt ) < 0 )
		{
			fprintf( stderr, "QMCK: sub_initial_proc (%s) create error\n", PATH_TEMP_DIR ) ;
			return -1 ;
		}
	}	

	// ***
	// ***	Get Working Directory Name
	// ***

	npnum = 0 ;
	sub_get_ctime( wrkbuf, sizeof(wrkbuf) ) ;

	while ( 1 )
	{
		sprintf( tmpbuf, "%s/%s%d", PATH_TEMP_DIR, wrkbuf, npnum ) ;

		if ( stat( tmpbuf, &stt ) < 0 )
		{
			break ;
		}
		
		npnum++ ;

		if ( npnum > 10 )
		{
			fprintf( stderr, "QMCK: sub_initial_proc directory name create error\n" ) ;
			return -1 ;
		}
	}

	nmask  = S_ISUID|S_ISGID|S_ISVTX|S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IWGRP|S_IXGRP ;
	nmask |= S_IROTH|S_IWOTH|S_IXOTH ;
	mkdir( tmpbuf, 777 ) ;
	chmod( tmpbuf, nmask ) ;

	if ( stat( tmpbuf, &stt ) < 0 )
	{
		fprintf( stderr, "QMCK: sub_initial_proc (%s) create error\n", tmpbuf ) ;
		return -1 ;
	}

	strcpy( pmf->path_wrkdir, tmpbuf ) ;

	// ***
	// ***	Set Mail Dir Name
	// ***
	
	sprintf( pmf->path_maildr, "%s/mail_message", 	tmpbuf ) ;
	sprintf( pmf->path_envelp, "%s/envelope", 		tmpbuf ) ;

	return 0 ;
}

