// *** ================================================================ ***
// ***  MAIL SCAN for QMAIL
// ***  --------------------------------------------------------------
// ***  Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***  Author Contact Address:
// ***      STARS System Inc. Technical Division.
// ***      2-3-11 Mahikizawa APT #2B
// ***      Tama-Shi, Tokyo, Japan 206-0023
// ***      TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***  --------------------------------------------------------------
// ***  Product Functionality
// ***
// *** ================================================================ ***

#include "qmail-checker.h"

int sub_process_mail(MAIN_INFO_T *pmf)
{
	FILE   *fp ;
	FILE   *fs ;
	char	wrkbuf[1024] ;	
	char   *pt ;
	
	// ***
	// ***	Check virus scan status
	// ***
	
	if ( pmf->stat_virus == 0 )
	{
		fprintf( stderr, "QMCK: sub_process_mail status OK re-queue message\n" ) ;
		return 0 ;
	}
	
	// ***
	// ***	Send warning to sender
	// ***

	sprintf( wrkbuf, "%s/send_mail_msg", pmf->path_wrkdir ) ;

	strcpy ( pmf->path_maildr, wrkbuf ) ;

	if ( (fp = fopen( wrkbuf, "w" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) create error\n", wrkbuf ) ;
		return -1 ;
	}

	fprintf( fp, "From: %s\n", pmf->mail_addres ) ;
	fprintf( fp, "To: %s\n", pmf->mail_from ) ;
	fprintf( fp, "Subject: virus mail warning by qmail-checker\n" ) ;
	fprintf( fp, "MIME-Version: 1.0\n" ) ;
	fprintf( fp, "Content-Type: text/plain; charset=iso-2022-jp\n" ) ;
	fprintf( fp, "\n" ) ;
	fprintf( fp, "* qmail-checker virus warning\n" ) ;
	fprintf( fp, "\n" ) ;
	fprintf( fp, "  qmail-checker detected virus on your email.\n" ) ;
	fprintf( fp, "  please check your mail content or consult to your\n" ) ;
	fprintf( fp, "  system administrator please.\n" ) ;
	fprintf( fp, "\n" ) ;
	fclose( fp ) ;

	sprintf( wrkbuf, "%s/send_mail_env", pmf->path_wrkdir ) ;

	strcpy ( pmf->path_envelp, wrkbuf ) ;

	if ( (fp = fopen( wrkbuf, "wb" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) create error\n", wrkbuf ) ;
		return -1 ;
	}

	fprintf( fp, "F%s", pmf->mail_addres ) ;
	fwrite ( "\0", 1, 1, fp ) ;

	sprintf( wrkbuf, "%s/env_data", pmf->path_wrkdir ) ;

	if ( (fs = fopen( wrkbuf, "r" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) open error\n", wrkbuf ) ;
		return -1 ;
	}

	fprintf( fp, "T%s", pmf->mail_from ) ;
	fwrite ( "\0", 1, 1, fp ) ;
	fwrite ( "\0", 1, 1, fp ) ;

	fclose( fs ) ;
	fclose( fp ) ;
	
	sub_send_qmailque( pmf ) ;

	// ***
	// ***	Send warning to receipient
	// ***

	sprintf( wrkbuf, "%s/send_mail_msg", pmf->path_wrkdir ) ;

	strcpy ( pmf->path_maildr, wrkbuf ) ;

	if ( (fp = fopen( wrkbuf, "w" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) create error\n", wrkbuf ) ;
		return -1 ;
	}

	fprintf( fp, "From: %s\n", pmf->mail_addres ) ;
	fprintf( fp, "To: mail_recipient\n" ) ;
	fprintf( fp, "Subject: virus mail warning by qmail-checker\n" ) ;
	fprintf( fp, "MIME-Version: 1.0\n" ) ;
	fprintf( fp, "Content-Type: text/plain; charset=iso-2022-jp\n" ) ;
	fprintf( fp, "\n" ) ;
	fprintf( fp, "* qmail-checker virus warning\n" ) ;
	fprintf( fp, "  qmail-checker detected virus and removed salfely.\n" ) ;
	fprintf( fp, "  the mail was sent by (%s).\n", pmf->mail_from ) ;
	fprintf( fp, "\n" ) ;
	fprintf( fp, "* qmail-checker\n" ) ;
	fprintf( fp, "  Powered by Stars System KK\n" ) ;
	fprintf( fp, "\n" ) ;
	fclose( fp ) ;

	sprintf( wrkbuf, "%s/send_mail_env", pmf->path_wrkdir ) ;

	strcpy ( pmf->path_envelp, wrkbuf ) ;

	if ( (fp = fopen( wrkbuf, "wb" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) create error\n", wrkbuf ) ;
		return -1 ;
	}

	fprintf( fp, "F%s", pmf->mail_addres ) ;
	fwrite ( "\0", 1, 1, fp ) ;

	sprintf( wrkbuf, "%s/env_data", pmf->path_wrkdir ) ;

	if ( (fs = fopen( wrkbuf, "r" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_process_mail (%s) open error\n", wrkbuf ) ;
		return -1 ;
	}

	while( fgets( wrkbuf, sizeof(wrkbuf), fs ) )
	{
		if ( (pt = strrchr( wrkbuf, '\n' )) != NULL )
		{
			*pt = 0 ;
		}
		fprintf( fp, "T%s", wrkbuf ) ;
		fwrite ( "\0", 1, 1, fp ) ;
	}
	fwrite ( "\0", 1, 1, fp ) ;

	fclose( fs ) ;
	fclose( fp ) ;
	
	sub_send_qmailque( pmf ) ;

	return -2 ;
}
