// *** ================================================================ ***
// ***  MAIL SCAN for QMAIL
// ***  --------------------------------------------------------------
// ***  Copyright 2004- By STARS System Ltd. Allrights Reserved
// ***  Author Contact Address:
// ***      STARS System Inc. Technical Division.
// ***      2-3-11 Mahikizawa APT #2B
// ***      Tama-Shi, Tokyo, Japan 206-0023
// ***      TEL: +81-42-310-1761, FAX: +81-42-310-1762
// ***  --------------------------------------------------------------
// ***  Product Functionality
// ***
// *** ================================================================ ***

#include "qmail-checker.h"

int sub_send_qmailque(MAIN_INFO_T *pmf)
{
  	int 	pipe1[2];					//	pipe for message
  	int 	pipe2[2];					//	pipe for envelope
	int		fd_msg ;					//	fd for message
	int		fd_env ;					// 	fd for envelope
	int		nlen ;
	int		npid ;
	int		nexit ;
	int		ncras ;
	char   *exec_args[2] ;
	char	filbuf[1024] ;
	FILE   *fp ;
	pid_t	nsts ;
	int		wstat ;

	// ***
	// ***	Initialize
	// ***

	memset( exec_args, 0, sizeof(exec_args) ) ;

	exec_args[0] = pmf->path_qmailq ;

	// ***
	// ***	Create Pipe
	// ***

  	if ( pipe(pipe1) == -1) 
	{
		return -1;
	}
  	if ( pipe(pipe2) == -1) 
	{ 
		close(pipe1[0]); 
		close(pipe1[1]); 
		return -1; 
	}

	// ***
	// ***
	// ***

  	switch( npid = vfork() ) 
	{
    case -1:	//	vfork error

		fprintf( stderr, "QMCK: sub_send_qmailque vfork failed\n" ) ;
      	close(pipe1[0]); 
		close(pipe1[1]);
      	close(pipe2[0]); 
		close(pipe2[1]);
      	return -1;

    case 0:		//	Child Process

      	close(pipe1[1]);
      	close(pipe2[1]);
      	if ( sub_fd_change( pmf, pipe1[0], 0 ) == -1 ) 
		{
			fprintf( stderr, "QMCK: sub_send_qmailque fd_change(0) failed\n" ) ;
			_exit(120);
		}
      	if ( sub_fd_change( pmf, pipe2[0], 1 ) == -1 ) 
		{
			fprintf( stderr, "QMCK: sub_send_qmailque fd_change(1) failed\n" ) ;
			_exit(120);
		}
		fprintf(stderr, "QMCK: sub_send_qmailque execute child\n" ) ;
      	execv(exec_args[0],exec_args);
		fprintf(stderr, "QMCK: sub_send_qmailque child ended\n" ) ;
      	_exit(120);
  	}

	// ***
	// ***	Parent Initialize
	// ***

  	fd_msg = pipe1[1]; 
	close(pipe1[0]);

  	fd_env = pipe2[1]; 
	close(pipe2[0]);

	// ***
	// ***	Send Message
	// ***

	if ( (fp = fopen( pmf->path_maildr, "r" )) == NULL )
	{
		fprintf( stderr, "QMCK: sub_send_qmailque could not open temp file\n" ) ;
		return -1 ;
	}
	
	while ( (nlen = fread( filbuf, 1, sizeof(filbuf), fp )) )
	{
		write( fd_msg, filbuf, nlen ) ;
	}

	fclose( fp ) ;
	
	fprintf( stderr, "QMCK: sub_send_qmailque: transfered message to qmail-queue\n" ) ;

	// ***
	// ***	Send Envelope
	// ***

	if ( (fp = fopen( pmf->path_envelp, "rb" )) == NULL )
    {
        fprintf( stderr, "QMCK: sub_send_qmailque could not open temp file\n" ) ;
        return -1 ;
    }

    while ( (nlen = fread( filbuf, 1, sizeof(filbuf), fp )) )
    {
        write( fd_env, filbuf, nlen ) ;
    }

    fclose( fp ) ;

    fprintf( stderr, "QMCK: sub_send_qmailque transfered envelope to qmail-queue\n" ) ;

	// ***
	// ***	Wait Child Process to exit
	// ***

    fprintf( stderr, "QMCK: sub_send_qmailque wait pid(%d) start\n", npid ) ;

    close( fd_msg ) ;
    close( fd_env ) ;

  	do
    	nsts = waitpid( npid, &wstat, 0 ) ;
  	while ( (nsts == -1) && (errno == EINTR) ) ;


	nexit = child_status ( wstat ) ;
	ncras = child_crashed( wstat ) ;

    fprintf( stderr, "QMCK: sub_send_qmailque child process ended. sts=%d, crashed=%d\n", nexit, ncras ) ;

	return 0 ;
}
